package org.zipcoder.store;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static java.util.stream.Collectors.toMap;

public class ListMap implements MyMap {
    // instance field that is intialize to an ArrayList
    private List<Entry> entries = new ArrayList<>();

    @Override
    public int size() {
        return entries.size();
    }

    @Override
    public boolean isEmptry() {
        if (size() < 1)
            return true;
        return false;
    }
    @Override
    public Cart get(User key) {
        Cart cart = null;

        for (Entry e : entries) {
            if (e.getKey().equals(key)) {
                cart = e.getValue();
                break;
            }
        }

        if (cart == null) {
            for (Entry e : entries) {
                if (e.getKey().getName().equals(key.getName())) {
                    cart = e.getValue();
                    break;
                }
            }
        }

        return cart;
    }

    @Override
    public void put(User key, Cart value) {
        // add the key, value entry to the entries list
        if (get(key) != null) remove(key);
        Entry entry = new Entry(key, value);
        entries.add(entry);
    }


    @Override
    public List<User> getKeys() {
        // get all the keys in the map
        ArrayList<User> keysList = new ArrayList<>();
        for (Entry e: entries){
            keysList.add(e.getKey());
        }
        return keysList;
    }

    @Override
    public List<Cart> getValues() {
        // get all the values in the map
        ArrayList<Cart> valueList = new ArrayList<>();
        for(Entry e: entries){
            valueList.add(e.getValue());
        }
        return valueList;
    }

    @Override
    public Cart remove(User key) {
        Cart cart = null;
        for (Entry e: entries){
            if(e.getKey().equals(key)){
                cart = e.getValue();
                entries.remove(e);
                break;
            }
        }
        return cart;
    }
}
