package org.zipcoder.store;

import java.util.*;

public class MyHashMap implements MyMap{
    // final field that doesn't change for any object
    private static final int BUCKET_SIZE = 15;
    private int size = 0;
    // instance field that can only be set once. It is different for every Object
    private final List<Entry>[] entries;

    public MyHashMap(){
        entries = new List[BUCKET_SIZE];

        for(int i = 0; i < BUCKET_SIZE; i++) {
            entries[i] = new ArrayList<>();
        }
    }

    @Override
    public int size() {
        return this.size;
    }

    @Override
    public boolean isEmptry() {
        if (size <= 0){
            return true;
        }
        return false;
    }

    @Override
    public Cart get(User key) {
        Cart cart = null;
        for (List<Entry> e: entries){
            for(Entry entry: e){
                if(entry.getKey().equals(key))
                    cart = entry.getValue();
                    break;
            }

        }

        if (cart == null){
            for (List<Entry> e: entries){
                for(Entry entry: e){
                    if(entry.getKey().getName().equals(key.getName()))
                        cart = entry.getValue();
                    break;
                }

            }
        }
        return cart;
    }

    @Override
    public void put(User key, Cart value) {

        ArrayList<Entry> myList = new ArrayList<>();
        Entry entry = new Entry(key, value);
        myList.add(entry);
        //int i=0;
        //if (size <= BUCKET_SIZE)
            entries[this.size++] = myList;
    }

    @Override
    public List<User> getKeys() {

        ArrayList<User> keys = new ArrayList<>();
        for(List<Entry> list: entries){
            for(Entry e: list){
                keys.add(e.getKey());
            }

        }
        return keys;
    }

    @Override
    public List<Cart> getValues() {
        ArrayList<Cart> values = new ArrayList<>();
        for(List<Entry> list: entries){
            for(Entry e: list){
                values.add(e.getValue());
            }

        }
        return values;
    }

    @Override
    public Cart remove(User key) {
        Cart cart = null;
        for(List<Entry> list: entries){
            for (Entry e: list){
                if(e.getKey().equals(key))
                    cart = e.getValue();
                    list.remove(e);
                    break;
            }

        }

        this.size--;
        return cart;
    }

    private int bucketIndex(User key){
        return Math.abs(key.hashCode()) % entries.length;
    }
}
